/* 
 * File:   aqSender.h
 * Author: matt
 *
 * Created on July 5, 2011, 12:48 AM
 */

#ifndef AQSENDER_H
#define	AQSENDER_H

#include <qpid/messaging/Message.h>
#include <qpid/messaging/Sender.h>
#include <qpid/messaging/Session.h>
#include "robokind/messaging/qpidavroUtils.h"

using namespace std;
using namespace qpid::messaging;


namespace robokind{
    class AQSender{
        private:
            Sender mySender;

        public:
            AQSender(const Sender &sender) :mySender(sender){}

            AQSender(Session* session, const char* destination){
                mySender = session->createSender(destination);
            }

            template<typename T> void send(T* t, string contentType="", bool sync=false){
                Message message = packMessage<T>(t);
                message.setContentType(contentType);
                mySender.send(message, sync);
            }
    };
}
#endif	/* AQSENDER_H */

