/* 
 * File:   aqStream.h
 * Author: matt
 *
 * Created on July 4, 2011, 8:47 PM
 */
#ifndef AQSTREAM_H
#define	AQSTREAM_H

#include <string.h>
#include <qpid/messaging/Connection.h>
#include <qpid/messaging/Message.h>
#include <qpid/messaging/Receiver.h>
#include <qpid/messaging/Sender.h>
#include <qpid/messaging/Session.h>
#include "robokind/messaging/AQReceiver.h"
#include "robokind/messaging/AQSender.h"
#include "robokind/messaging/AQDrain.h"

#define BROKER_LEN 1024
#define OPTIONS_LEN 1024

using namespace std;
using namespace qpid::messaging;

/*Avro-Qpid Stream*/
namespace robokind{
    class AQStream{
        public:
            AQStream(const char* broker="localhost:5672", const char* options="{username:admin,password:admin}");

            char* getBrokerAddress();
            void setBrokerAddress(const char* address);

            char* getConnectionOptions();
            void setConnectionOptions(const char* options);

            bool connect();
            void disconnect();

            AQSender* createSender(const char* destination);
            AQReceiver* createReceiver(const char* destination);
            AQDrain* createDrain(const char* destination);
        protected:
            char* myBrokerAddress;
            char* myConnectionOptions;

            Connection* myConnection;
            Session mySession;
    };
}

#endif	/* AQSTREAM_H */

