/* 
 * File:   ImageDisplayService.h
 * Author: matt
 *
 * Created on July 15, 2011, 5:35 AM
 */

#ifndef IMAGEDISPLAYSERVICE_H
#define	IMAGEDISPLAYSERVICE_H


#include <cstdlib>
#include <string.h>
#include <qpid/messaging/Message.h>
#include "robokind/messaging/AQService.h"
#include "robokind/messaging/AQReceiver.h"
#include "robokind/vision/display/protocol/ImageDisplayConfig.h"


using namespace std;
using namespace qpid::messaging;

namespace robokind{
    class ImageDisplayService : public AQService<ImageDisplayConfig>{
        private:
            AQReceiver* myImageReceiver;
            AQReceiver* myAnnotationReceiver;
            int myDrawTime;
            Message myMessage;
            string myWinName;

            void threadSafeWorker();
            
            bool _initialize(ImageDisplayConfig* conf);
            void close();
        public:
            void handleCommandMessage(Message &msg);
            int getFrameLength();
            void setFrameLength(int len);    
    };
}

#endif	/* IMAGEDISPLAYSERVICE_H */

