/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef IMAGEDISPLAYCONFIG_H_3007213051__H_
#define IMAGEDISPLAYCONFIG_H_3007213051__H_


#include <boost/any.hpp>
#include <avro/Specific.hh>
#include <avro/Encoder.hh>
#include <avro/Decoder.hh>
struct ImageDisplayConfig {
    std::string brokerAddress;
    std::string connectionOptions;
    std::string imageQueue;
    std::string annotationQueue;
    int32_t drawRate;
    std::string windowName;
};

namespace avro {
template<> struct codec_traits<ImageDisplayConfig> {
    static void encode(Encoder& e, const ImageDisplayConfig& v) {
        avro::encode(e, v.brokerAddress);
        avro::encode(e, v.connectionOptions);
        avro::encode(e, v.imageQueue);
        avro::encode(e, v.annotationQueue);
        avro::encode(e, v.drawRate);
        avro::encode(e, v.windowName);
    }
    static void decode(Decoder& d, ImageDisplayConfig& v) {
        avro::decode(d, v.brokerAddress);
        avro::decode(d, v.connectionOptions);
        avro::decode(d, v.imageQueue);
        avro::decode(d, v.annotationQueue);
        avro::decode(d, v.drawRate);
        avro::decode(d, v.windowName);
    }
};

}
#endif
