#include "robokind/messaging/AQDrain.h"
#include <iostream>
#include "robokind/common/logger.h"

using namespace robokind;
using namespace robokind::common;

AQDrain::AQDrain(Session *session, const Receiver &receiver, int drainTimeout)
        :mySession(session), myReceiver(receiver), 
         myDrainTimeout(drainTimeout), myDrainCount(0){}

AQDrain::AQDrain(Session* session, const char* destination, int drainTimeout)
        :mySession(session), myDrainTimeout(drainTimeout), myDrainCount(0){
    myReceiver = session->createReceiver(destination);
}

void AQDrain::drain(){
    cout << "Draining from receiver: " <<  myReceiver.getName() << endl;
    drainLoop();
    cout << myDrainCount << " messages drained." << endl;
    cout << "Draining complete - " << myReceiver.getName() << endl;
}

void AQDrain::drainLoop(){
    try{
        while(myReceiver.fetch(myMessage, myDrainTimeout)){
            mySession->acknowledge();
            myDrainCount++;
            cout << ".";
        }
    }catch(const NoMessageAvailable &ex){
        return;
    }catch(const MessagingException &ex){
        robokind::common::error("Error while draining.", ex);
    }catch(...){
        robokind::common::error("Unspecified error while draining");
    }
}
